<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}

/** 
 * Table of Contents
 * 
 * 1. Shortcode
 * 2. Elementor Widget Creator
 */

//1. Shortcode
function ohn_builder($params, $content) {
    extract( shortcode_atts( 
        array(
            'version'                       => '',
            'list'                          => '',
            'position'                      => '',
            'orientation'                   => '',
            'icons_mobile'                  => '',
            'icon'                          => '',
            'label'                         => '',
            'link_section'                  => '',
            'bg_color_active_v1'            => '',
            'label_color_active_v1'         => '',
            'bg_color_active_v2'            => '',
            'border_color_v2 '              => '',
            'label_color_active_v2'         => '',
            'label_color_active_v3'         => '',
            'icon_color_v3'                 => '',
            'bg_icon_active_v3'             => '',
            'bg_color_active_v3'            => '',
            'label_color_v4'                => '',
            'icon_active_color_v4'          => '',

        ), $params ) ); 
        
        ob_start(); 

        $version_class = 'v1';
        $position_class = 'bottom-center';
        $orientation_class = 'ohn-horizontal';
        $icons_mobile_class = 'all';

        if($version) {
            $version_class = $version;
        }

        if($position) {
            $position_class = $position;
        }

        if($orientation) {
            $orientation_class = $orientation;
        }

        if($orientation == 'ohn-horizontal') {
            $position_based = 'horizontal';
        } else {
            $position_based = 'vertical';
        }

        if($icons_mobile) {
            $icons_mobile_class = $icons_mobile;
        }
        

        ?>
        <?php if (array_key_exists('list', $params)) { ?>
            <?php $list = unserialize(base64_decode($list));?>
                  <nav id="ohn-menu-nav-scroll" class="ohn-side-menu <?php echo esc_attr($version_class.' '.$position_class.' '.$position_based); ?>">
                      <ul class="<?php echo esc_attr($orientation_class.' '.$icons_mobile_class); ?>">
                        <?php if (is_array($list) || is_object($list)) {
                        $first_item = true;
                        foreach ($list as $item) {
                            $label = $item['label'];
                            $link_section = $item['link_section'];
                        ?>
                            <li<?php if ($first_item) : ?> class="active"<?php $first_item = false; endif; ?>>
                                <a href="<?php echo esc_attr($link_section); ?>">
                                    <?php if (in_array($version_class, ['ohn-v1', 'ohn-v3', 'ohn-v4'])) {
                                        \Elementor\Icons_Manager::render_icon($item['icon'], ['aria-hidden' => 'true']);
                                    } ?>
                                    <span><?php echo esc_html($label); ?></span>
                                </a>
                            </li>
                    <?php } ?>
                   <?php } ?>
                      </ul>
                  </nav>
            <?php  } ?>
        <?php

        return ob_get_clean();
    }
add_shortcode('ohn-builder-shortcode', 'ohn_builder');

// 2. Elementor Widget Creator
if (in_array('elementor/elementor.php', apply_filters('active_plugins', get_option('active_plugins')))) {
    class OHN_Elementor_Widgets {

        protected static $instance = null;

        public static function get_instance() {
            if ( ! isset( static::$instance ) ) {
                static::$instance = new static;
            }

            return static::$instance;
        }

        protected function __construct() {
            require_once('elementor.php');

            add_action( 'elementor/widgets/widgets_registered', [ $this, 'register_widgets' ] );
        }

        public function register_widgets() {
            \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new \Elementor\OHN_Widget() );
        }

    }

    // Elementor Init
    add_action( 'init', 'ohn_elementor_init' );
    function ohn_elementor_init() {
        OHN_Elementor_Widgets::get_instance();
    }

    // Elementor Widgets Category
    function ohn_widget_categories( $elements_manager ) {
        $elements_manager->add_category(
            'modeltheme-widgets',
            [
                'title' => esc_html__( 'Modeltheme Widgets', 'ohn' ),
                'icon' => 'fas fa-plug',
            ]
        );
    }
    add_action( 'elementor/elements/categories_registered', 'ohn_widget_categories' );
}

